package sun.rmi.registry;

import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;
import java.rmi.AccessException;
import java.rmi.AlreadyBoundException;
import java.rmi.MarshalException;
import java.rmi.NotBoundException;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.UnexpectedException;
import java.rmi.UnmarshalException;
import java.rmi.registry.Registry;
import java.rmi.server.Operation;
import java.rmi.server.RemoteCall;
import java.rmi.server.RemoteRef;
import java.rmi.server.RemoteStub;

public final class RegistryImpl_Stub extends RemoteStub implements Registry, Remote {
   private static Operation[] operations = new Operation[]{new Operation("void bind(java.lang.String, java.rmi.Remote)"), new Operation("java.lang.String list()[]"), new Operation("java.rmi.Remote lookup(java.lang.String)"), new Operation("void rebind(java.lang.String, java.rmi.Remote)"), new Operation("void unbind(java.lang.String)")};
   private static final long interfaceHash = 4905912898345647071L;

   public RegistryImpl_Stub() {
   }

   public RegistryImpl_Stub(RemoteRef var1) {
      super(var1);
   }

   public void bind(String var1, Remote var2) throws AccessException, AlreadyBoundException, RemoteException {
      byte var3 = 0;
      RemoteRef var4 = super.ref;
      RemoteCall var5 = var4.newCall(this, operations, var3, 4905912898345647071L);

      try {
         ObjectOutput var6 = var5.getOutputStream();
         var6.writeObject(var1);
         var6.writeObject(var2);
      } catch (IOException var10) {
         throw new MarshalException("Error marshaling arguments", var10);
      }

      try {
         var4.invoke(var5);
      } catch (AlreadyBoundException var7) {
         throw var7;
      } catch (RemoteException var8) {
         throw var8;
      } catch (Exception var9) {
         throw new UnexpectedException("Unexpected exception", var9);
      }

      var4.done(var5);
   }

   public String[] list() throws AccessException, RemoteException {
      byte var1 = 1;
      RemoteRef var2 = super.ref;
      RemoteCall var3 = var2.newCall(this, operations, var1, 4905912898345647071L);

      try {
         var2.invoke(var3);
      } catch (RemoteException var18) {
         throw var18;
      } catch (Exception var19) {
         throw new UnexpectedException("Unexpected exception", var19);
      }

      String[] var4;
      try {
         ObjectInput var7 = var3.getInputStream();
         var4 = (String[])var7.readObject();
      } catch (IOException var14) {
         throw new UnmarshalException("Error unmarshaling return", var14);
      } catch (ClassNotFoundException var15) {
         throw new UnmarshalException("Return value class not found", var15);
      } catch (Exception var16) {
         throw new UnexpectedException("Unexpected exception", var16);
      } finally {
         var2.done(var3);
      }

      return var4;
   }

   public Remote lookup(String var1) throws AccessException, NotBoundException, RemoteException {
      byte var2 = 2;
      RemoteRef var3 = super.ref;
      RemoteCall var4 = var3.newCall(this, operations, var2, 4905912898345647071L);

      try {
         ObjectOutput var5 = var4.getOutputStream();
         var5.writeObject(var1);
      } catch (IOException var24) {
         throw new MarshalException("Error marshaling arguments", var24);
      }

      try {
         var3.invoke(var4);
      } catch (NotBoundException var21) {
         throw var21;
      } catch (RemoteException var22) {
         throw var22;
      } catch (Exception var23) {
         throw new UnexpectedException("Unexpected exception", var23);
      }

      Remote var25;
      try {
         ObjectInput var8 = var4.getInputStream();
         var25 = (Remote)var8.readObject();
      } catch (IOException var17) {
         throw new UnmarshalException("Error unmarshaling return", var17);
      } catch (ClassNotFoundException var18) {
         throw new UnmarshalException("Return value class not found", var18);
      } catch (Exception var19) {
         throw new UnexpectedException("Unexpected exception", var19);
      } finally {
         var3.done(var4);
      }

      return var25;
   }

   public void rebind(String var1, Remote var2) throws AccessException, RemoteException {
      byte var3 = 3;
      RemoteRef var4 = super.ref;
      RemoteCall var5 = var4.newCall(this, operations, var3, 4905912898345647071L);

      try {
         ObjectOutput var6 = var5.getOutputStream();
         var6.writeObject(var1);
         var6.writeObject(var2);
      } catch (IOException var9) {
         throw new MarshalException("Error marshaling arguments", var9);
      }

      try {
         var4.invoke(var5);
      } catch (RemoteException var7) {
         throw var7;
      } catch (Exception var8) {
         throw new UnexpectedException("Unexpected exception", var8);
      }

      var4.done(var5);
   }

   public void unbind(String var1) throws AccessException, NotBoundException, RemoteException {
      byte var2 = 4;
      RemoteRef var3 = super.ref;
      RemoteCall var4 = var3.newCall(this, operations, var2, 4905912898345647071L);

      try {
         ObjectOutput var5 = var4.getOutputStream();
         var5.writeObject(var1);
      } catch (IOException var9) {
         throw new MarshalException("Error marshaling arguments", var9);
      }

      try {
         var3.invoke(var4);
      } catch (NotBoundException var6) {
         throw var6;
      } catch (RemoteException var7) {
         throw var7;
      } catch (Exception var8) {
         throw new UnexpectedException("Unexpected exception", var8);
      }

      var3.done(var4);
   }
}
